/*
 * Display.c
 *
 * Created: 26.02.2013 14:04:47
 *  Author: Stefan Rttimann
 */ 

	#include <avr/io.h>
	#include <avr/interrupt.h>
	#include <stdlib.h>
	#include "Display.h"
	#include "delay.h"
	
//Variablen

	static uint8_t MotorPowerFr = 8;
	static uint8_t MotorPowerRe = 8;
	static uint8_t TractionCont = 8;
	static uint8_t TorqueVec = 8;
	static uint8_t Ruckgabe = 0;
	char Wert1[3];
	char Wert2[3];
	uint8_t data = 0;
	uint8_t busy = 1;
	
//Funktionen

 uint8_t ShowDisplay(uint8_t Modus, uint8_t MinWert, uint8_t MaxWert, uint8_t Plus, uint8_t Minus, uint8_t Fehlercode)
 {
	 lcd_setcursor(0,1);
	 lcd_string("                ");
	 lcd_setcursor(0,2);
	 lcd_string("                ");
	 //Auswahl des Display-Modus in dem man sich befindet und Textausgabe
	switch (Modus) {
		
		case 0: {
					lcd_setcursor(6,1);
					lcd_string("AMZ");
					lcd_setcursor(5,2);
					lcd_string("JULIER");
					return(Ruckgabe);
				}
				break;
		
		case 1: {
					lcd_setcursor(3,1);
					lcd_string("SOC");
					lcd_setcursor(10,1);
					lcd_string("SOH");
					
					itoa(MinWert,Wert1,10);
					itoa(MaxWert,Wert2,10);
					lcd_setcursor(3,2);
					lcd_string(Wert1);
					lcd_string("%");
					lcd_setcursor(10,2);
					lcd_string(Wert2);
					lcd_string("%");
					return(Ruckgabe);
				}
				break;
		
		case 2: {
					lcd_setcursor(2,1);
					lcd_string("min  CV  max");
					
					itoa(MinWert,Wert1,10);
					itoa(MaxWert,Wert2,10);
					lcd_setcursor(1,2);
					lcd_string(Wert1);
					lcd_string("V");
					lcd_setcursor(10,2);
					lcd_string(Wert2);
					lcd_string("V");
					return(Ruckgabe);			
				}
				break;
		
		case 3: {
					lcd_setcursor(2,1);
					lcd_string("min  CT  max");
					
					itoa(MinWert,Wert1,10);
					itoa(MaxWert,Wert2,10);
					lcd_setcursor(2,2);
					lcd_string(Wert1);
					lcd_data(0b11011111);
					lcd_string("C");
					lcd_setcursor(11,2);
					lcd_string(Wert2);
					lcd_data(0b11011111);
					lcd_string("C");
					return(Ruckgabe);		
				}
				break;
		
		case 4: {
					lcd_setcursor(3,1);
					lcd_string("LV-Voltage");
					
					itoa(MinWert,Wert1,10);
					lcd_setcursor(8,2);
					lcd_string(Wert1);
					lcd_string("V");
					return(Ruckgabe);
				}
				break;
		
		case 5: {
					lcd_setcursor(3,1);
					lcd_string("L  MT-F  R");
					
					itoa(MinWert,Wert1,10);
					itoa(MaxWert,Wert2,10);
					lcd_setcursor(2,2);
					lcd_string(Wert1);
					lcd_data(0b11011111);
					lcd_string("C");
					lcd_setcursor(11,2);
					lcd_string(Wert2);
					lcd_data(0b11011111);
					lcd_string("C");
					return(Ruckgabe);
				}
				break;
		
		case 6: {
					lcd_setcursor(3,1);
					lcd_string("L  MT-R  R");
					
					itoa(MinWert,Wert1,10);
					itoa(MaxWert,Wert2,10);
					lcd_setcursor(2,2);
					lcd_string(Wert1);
					lcd_data(0b11011111);
					lcd_string("C");
					lcd_setcursor(11,2);
					lcd_string(Wert2);
					lcd_data(0b11011111);
					lcd_string("C");
					return(Ruckgabe);
				}
				break;
		
		case 7: {
					if(Plus)
					{
						MotorPowerFr++;
					}
					if (Minus)
					{
						MotorPowerFr--;
					}
					lcd_setcursor(0,1);
					lcd_string("Motorpower-Front");
					lcd_setcursor(0,2);
					uint8_t i=0;
					while ( i < MotorPowerFr)
					{
						lcd_data(0b11111111);
						i++;
					}
					return(MotorPowerFr);
				}
				break;
				
		case 8: {
					if(Plus)
					{
						MotorPowerRe++;
					}
					if (Minus)
					{
						MotorPowerRe--;
					}
					lcd_setcursor(0,1);
					lcd_string("Motorpower-Rear");
					lcd_setcursor(0,2);
					uint8_t i=0;
					while ( i < MotorPowerRe)
					{
						lcd_data(0b11111111);
						i++;
					}
					return(MotorPowerRe);
				}
				break;
		
		case 9: {
					if(Plus)
					{
						TractionCont++;
					}
					if (Minus)
					{
						TractionCont--;
					}
					lcd_setcursor(0,1);
					lcd_string("Traction-Control");
					lcd_setcursor(0,2);
					uint8_t i=0;
					while ( i < TractionCont)
					{
						lcd_data(0b11111111);
						i++;
					}
					return(TractionCont);
				}
				break;
		
		case 10: {
					if(Plus)
					{
						TorqueVec++;
					}
					if (Minus)
					{
						TorqueVec--;
					}
					lcd_setcursor(0,1);
					lcd_string("Torque-Vectoring");
					lcd_setcursor(0,2);
					uint8_t i=0;
					while ( i < TorqueVec)
					{
						lcd_data(0b11111111);
						i++;
					}
					return(TorqueVec);
				}
				break;
		
		case 11: {
					lcd_setcursor(0,1);
					lcd_string("     FEHLER     ");
					lcd_setcursor(0,2);
					lcd_string("      ????      ");
					return(Ruckgabe);
				}
				break;
		
		default: {
					return(Ruckgabe);
				}
				break;
	}
	
 }


 void InitDisplay(void)
 {

    // verwendete Pins auf Ausgang schalten
    LCD_DDR = 0xFF;
	LCD_STEUDDR = 0xFF;
    
    // initial alle Ausgnge auf Null
    LCD_PORT &= 0x00;
    
    // warten auf die Bereitschaft des LCD
    _delay_ms( 15 );
    
    // 8-bit Modus / 2 Zeilen / 5x7
    lcd_command( LCD_SET_FUNCTION | LCD_FUNCTION_8BIT | LCD_FUNCTION_2LINE | LCD_FUNCTION_5X7 );
    
    // Display ein / Cursor aus / Blinken aus
    lcd_command( LCD_SET_DISPLAY | LCD_DISPLAY_ON | LCD_CURSOR_OFF | LCD_BLINKING_OFF);
    
    // Cursor inkrement / kein Scrollen
    lcd_command( LCD_SET_ENTRY | LCD_ENTRY_INCREASE | LCD_ENTRY_NOSHIFT );
    
    lcd_command( LCD_CLEAR_DISPLAY );	

 }
 
 //Enable Puls erzeugen
 static void lcd_enable( void )
 {
	 cli();									//All interrupts disable
	 LCD_STEU |= (1<<LCD_EN);				// Enable auf 1 setzen
/*	 while (busy)							// BusyFlag kontrollieren
	 {
		LCD_DDR = 0x00;						// Datenbits als Eingang setzen
		LCD_STEU &= ~(1<<LCD_RS);			// RS auf 0 setzen
		LCD_STEU |= (1<<LCD_RW);			// RW auf 1 setzen
		busy = !(LCD_PORT & 0b10000000);
	 }*/
	_delay_us(100);
	 LCD_STEU &= ~(1<<LCD_EN);				// Enable auf 0 setzen
	 sei();									//General interrupt enable
	 LCD_DDR = 0xFF;						// Datenbits als Ausgang setzen
	 LCD_PORT &= 0x00;
 }
 
 //String aufs Display schreiben
 void lcd_string( const char *data )
 {
	 while( *data != '\0' )
	 lcd_data( *data++ );
 }
 
 //Daten aufs Display schreiben
void lcd_data( uint8_t data )
{
	LCD_STEU |= (1<<LCD_RS);				// RS auf 1 setzen
	LCD_STEU &= ~(1<<LCD_RW);				// RW auf 0 setzen
	LCD_PORT |= ( data );					// Zeichen senden
	lcd_enable();							// Warten bis ausgefhrt
}

//Command an Display senden
void lcd_command( uint8_t data )
{
	LCD_STEU &= ~(1<<LCD_RS);				// RS auf 0 setzen
	LCD_STEU &= ~(1<<LCD_RW);				// RW auf 0 setzen
	LCD_PORT |= ( data );					// Kommando senden
	lcd_enable();							// Warten bis ausgefhrt
}

//Cursor setzen
void lcd_setcursor( uint8_t x, uint8_t y )
{
	switch (y)
	{
		case 1:								// 1. Zeile
		data = LCD_SET_DDADR + LCD_DDADR_LINE1 + x;
		break;
		
		case 2:								// 2. Zeile
		data = LCD_SET_DDADR + LCD_DDADR_LINE2 + x;
		break;
		
		default:
		return;								// fr den Fall einer falschen Zeile
	}
	
	lcd_command( data );
}


