/*
 * LED.c
 *
 * Created: 26.02.2013 14:04:47
 *  Author: Stefan Rttimann
 */ 

	#include <avr/io.h>
	#include <avr/eeprom.h>

	#include "LED.h"
	#include "delay.h"

void InitLED(void)
{
	DDRB |= 0b11111101;			//LED-Signale als Output
	PORTB &= 0b00000010;		//LED = Off

	DDRG |= 0b11000;			//EnableGreen, EnableRed als Output
	PORTG |= 0b11000;			//EnableGreen, EnableRed Enable
	
	_delay_us(50);				//Warte bis Signal angelegt
	PORTG &= 0b00111;			//EnableGreen, EnableRed disable

}


void SetLED_Green (uint8_t LEDgreen)
{
	PORTB = (0b11111101 & LEDgreen); //LED = ein

	PORTG |= 0b01000;			//EnableGreen Enable
	_delay_us(1);				//Warte bis Signal angelegt
	PORTG &= 0b10111;			//EnableGreen desable
	PORTB &= 0b00000010;
}

void SetLED_Red (uint8_t LEDred)
{
	PORTB = (0b11111101 & LEDred); //LED = ein

	PORTG |= 0b10000;			//EnableRed Enable
	_delay_us(1);				//Warte bis Signal angelegt
	PORTG &= 0b01111;			//EnableRed desable
	PORTB &= 0b00000010;
}


