/*
 * Timer1.c
 *
 * Created: 26.02.2013 14:04:47
 *  Author: Stefan Rttimann
 */ 

#include "Timer1.h"
#include <avr/interrupt.h>


void InitTimer1(void){
	//Timer/Counter1 gives the trigger for the state machine -> all 200msec
	TCCR1A = (0<<COM1A1)|(0<<COM1A0);			//Normal Operation, no connection to the pin's
	TCCR1B = (1<<WGM12)|(1<<CS11)|(1<<CS10);	//Mode4 CTC ; Prescaler: 64
	TCCR1C = 0x00;

	OCR1A = 37524;								//37524 -> 64/12MHz = 5.33usec -> 37524*5.33usec = 200ms
	
	TIMSK1 = 0x00;								//All timer IRQ's will be activated at the entrance of the main loop	
}

void Timer1_On (void)
{
		TCNT1 = 0x0000;							//Reset the timer to zero
		TIMSK1 = (1<<OCIE1A);					//Activates the timers IRQ channel
}



